/* *****************************************************
    Thanks Chishm and DarkFader for releasing your sources.

    Borrowed header CRC functions from NDSTool
    Added DLDI tool customized with a static DLDI file.

    I am applying no lisence other than what was originally
    inteded by the authors of NDSTool and DLDITool.
  ******************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "little.h"
#include "header.h"
#include "crc.h"
#include "dlditool.h"

#define _HALT_

#define PROG_NAME "DLDIFix.exe"
#define false 0
#define true 1

void usage()
{
printf("\nDLDIFixV\n");
printf("-------------------------------------\n");
printf("Drag and drop a file or\n");
printf("use: %s file.ext\n", PROG_NAME);
printf("-------------------------------------\n");
}

//CalcHeaderCRC
unsigned short CalcHeaderCRC(Header &header)
{
    return CalcCrc16((unsigned char *)&header, 0x15E);
}


int main(int argc, char *argv[])
{
    FILE *inp;       /* In and out FILE Streams to read/write data */
    Header header;
    char code[] = {"    "};
    char fileName[MAXPATHLEN];
    int typef = 0;

    /* Error check the command line */
    if(argc != 2)
    {  
        #ifdef _HALT_
        usage();                  /* Display Usage Information on error */
        printf("\npress <enter> to quit...\n");
        fgetc(stdin);
        #endif
        return 0;               /* Exit Program returning 0 - no error */
    }

    strcpy(fileName, argv[1]);

    printf("\n DLDIFix: EZV DLDI and Header Patcher\n");
    printf("=--------------------------------------------------------=\n");
    printf(" |Until they fix it properly here is a little hack based|\n"
           " |on the excellent NDSTool and DLDI tools.              |\n"
           "=--------------------------------------------------------=\n\n");
    printf("Examining: %s\n\n",fileName);

    dldi_patch(fileName, typef);
    if(typef)
    {
        printf("NDS file, attempting to patch the header\n");
        inp = fopen(argv[1], "r+b");
        if (!inp)
        {
            #ifdef _HALT_
            printf("Cannot open file '%s'.\n", argv[1]);
            printf("\npress <enter> to quit...\n");
            fgetc(stdin);
            #endif
            return 0;
        }
        fread(&header, 512, 1, inp);
        memcpy(code, header.gamecode, 4);
        printf("\n Old Gamecode: %s", code);
        memcpy(header.gamecode, "PASS", 4);
        header.header_crc = CalcHeaderCRC(header);
        memcpy(code, header.gamecode, 4);
        printf("\n New Gamecode: %s", code);
        fseek(inp, 0, SEEK_SET);
        fwrite(&header, 512, 1, inp);
        fclose(inp);
    }
    else printf("Not a plain .nds file, header not patched\n");

    #ifdef _HALT_
    printf("\nDLDIFixV Finished.\n");
    printf("\npress <enter> to quit...\n");
    #endif
    fgetc(stdin);

    return 0;
}

